#include "xc.h"

#define SYSTEM_CLOCK 32000000UL

#include "LTlib.h"

#include "HW_mini_Sensing_PIC_Board.h"
#include "HW_mini_Sensing_USB.h"

#include "LTlib_utilities.h"
#include "LTlib_utilities.c"

#include "module_IO.h"  
#include "module_IO.c" 

#include "LTlib_delay.h"
#include "LTlib_delay.c"

#include "module_UART.h"  
#include "module_UART.c" 

int main (void){
    
    uint8_t readback = 0x00;
    
    IO_set_all_ports_as_inputs ();
    
    delay_set_quartz(32);
    
    UART1_open (UART_BAUDRATE_19200);  
    
    //Set LED as output
    LED_1_USB_DIR = SET_AS_OUTPUT;
    LED_2_USB_DIR = SET_AS_OUTPUT;
    LED_3_USB_DIR = SET_AS_OUTPUT;
    LED_4_USB_DIR = SET_AS_OUTPUT;
    
    SW_1_USB_DIR = SET_AS_INPUT;
    SW_2_USB_DIR = SET_AS_INPUT;
  
    //Initialization
    LED_1_USB = LED_OFF;
    LED_2_USB = LED_OFF;
    LED_3_USB = LED_OFF;
    LED_4_USB = LED_OFF;

    delay_ms (500);
    LED_1_USB = LED_ON;
    delay_ms (500);
    LED_2_USB = LED_ON;
    delay_ms (500);
    LED_3_USB = LED_ON;
    delay_ms (500);
    LED_4_USB = LED_ON;
    delay_ms (500);

    UART1_write_message ("Terminal Ready..."); 
    UART1_write_byte(10);
    
    UART1_write_message ("Press a button on the board or on the keyboard."); 
    UART1_write_byte(10);
    UART1_write_byte(10);
    
    while (1){
 
        if (SW_1_USB == BUTTON_PRESSED){
            LED_1_USB = LED_ON;
            LED_2_USB = LED_ON; 
            UART1_write_message ("SW1 pressed"); 
            UART1_write_byte(10);
            delay_ms(500);
        } else {
            LED_1_USB = LED_OFF;
            LED_2_USB = LED_OFF; 
        }
        
        if (SW_2_USB == BUTTON_PRESSED){
            LED_3_USB = LED_ON;
            LED_4_USB = LED_ON;
            UART1_write_message ("SW2 pressed"); 
            UART1_write_byte(10);
            delay_ms(500);
        } else {
            LED_3_USB = LED_OFF;
            LED_4_USB = LED_OFF; 
        }
        
        //Check if any keyboard key has been pressed and echo it + 1
        if (UART1_data_ready() == 0x01){
            
            readback = UART1_read_byte();
            
            UART1_write_byte(10);
            UART1_write_message ("Echo: "); 
            
            //echo with +1 on the ASCII code
            UART1_write_byte (readback + 1);
            UART1_write_byte (10);
           
        }        
    }    
}


